Revision history for Perl module CPAN::Reporter

1.2017    2016-03-02 15:49:43-05:00 America/New_York

  [CHANGED]

  - Distributions that appear to be in a Perl6/ directory are not
    graded and reports are discarded.

1.2016    2016-02-28 22:39:04-05:00 America/New_York

  [FIXED]

  - Improve prerequisite version detection for dynamic versions

  - Add support for static Config like cperl and XSConfig

1.2015    2015-08-21 17:53:31-04:00 America/New_York

  - Allow custom comment strings to be used as the default comment, using
    comment.txt in the config directory [JMASLAK]

1.2014    2015-04-06 12:08:28-04:00 America/New_York

  - no changes from 1.2013-TRIAL

1.2013    2015-03-29 21:52:11-04:00 America/New_York (TRIAL RELEASE)

  [ADDED]

  - Added experimental option to save output of hanging modules [CHORNY]

  - Added experimental option to save list of hanging modules [CHORNY]

  [CHANGED]

  - C::R::PrereqCheck will read <> before checking modules

  [FIXED]

  - Fixed incorrect report grade edge case [CHORNY]

  - Fixed tests for Perls on Windows with spaces in the path

  - Added Dancer::Plugin::FlashNote to list of prereq-check conflicts

  [TESTING]

  - Tests for C::R::PrereqCheck added

1.2011    2014-03-16 22:27:56+01:00 Europe/Paris

  [ADDED]

  - Added support for future optional prerequisite reporting
    when CPAN.pm supports it

  [CHANGED]

  - Moved test distributions into corpus/ to avoid repetitive
    tarball unpacking

  - Modernized distribution meta and support files

1.2010    2013-04-12 15:35:38 Europe/London

  [NEW FEATURES]

  - new option 'retry_submission' tries to send the report one
    extra time in case it fails. Defaults to undef (don't retry)
    (Patch by Alexandr "chorny" Ciornii)

1.2009    2012-12-18 16:08:37 America/New_York

  [BUG FIXES]

  - Expanded prerequisite load check skip to all Acme::* modules; prereqs
    still need to be installed and of sufficient version, but we don't
    check that Acme modules load without error to avoid side effects.

1.2008    2012-12-15 07:26:11 America/New_York

  [BUG FIXES]

  - Don't try to check if Acme::Bleach can be loaded if it's listed
    as a prereq

1.2007    2012-12-10 15:13:22 America/New_York


  [BUG FIXES]

  - Recognize another form of "Perl is too low" message [CHORNY]

1.2006    2012-04-10 18:44:20 America/New_York

  [BUG FIXES]

  - Changed how CPAN::Reporter::PrereqCheck attempts to load modules to
    avoid module reloading, which caused some prereqs to show up as
    'broken' [rt.cpan.org #76394 and #75559]

  [OTHER]

  - Bumped IPC::Cmd prereq to 0.76 to avoid failures on some platforms

1.2005    2012-03-02 13:21:36 EST5EDT

  [BUG FIXES]

  - Canonicalise the config path returned by bsd_glob [rt.cpan.org #70504]
    [Kent Fredric]

1.2004    2012-02-13 16:25:07 EST5EDT

  [BUG FIXES]

  - Fix bug in testing tilde expansion on Windows
    [rt.cpan.org #72051]

1.2003    2011-12-06 11:07:04 EST5EDT

  [BUG FIXES]

  - Fix bug in transport class validation to allow multi-level
    class names [rt.cpan.org #73045]

1.2002    2011-08-10 17:52:08 America/New_York

  [BUG FIXES]

  - Fix failing tests on systems without
    Test::Reporter::Transport::Metabase
  - Minor test cleanups for use with 'prove'

1.2001    2011-08-07 05:05:58 America/New_York

  [BUG FIXES]

  - Fix failing test on Windows due to glob expansion of "~"
    [Christian Walde]

1.20      2011-08-05 13:17:20 America/New_York

  [BUG FIXES]

  - Removed Test::Reporter::Transport::Metabase as a prerequisite.
    New testers are recommended to install Task::CPAN::Reporter instead
    of CPAN::Reporter.

1.19_04   2011-06-29 17:39:25 America/New_York

  [NEW FEATURES]

  - Metabase profile generation will use as much of the provided
    email_from parameter as possible and will generate a random
    secret API key.  If user provides email_from in a standard form
    like C<< "John Q. Public" <jqp@example.com> >> then profile
    generation is entirely automatic without additional prompts
    from metabase-profile [David Golden]

  [DOCUMENTATION]

  - Swapped in Task::CPAN::Reporter in the SYNOPSIS [David Golden]

  [BUG FIXES]

  - Expands "~" into user directory before attempting to locate
    'relative' pathname in .cpanreporter directory [David Golden]

1.19_03   2011-06-28 14:44:19 America/New_York

  [NEW FEATURES]
  - During configuration, if 'Metabase' is the requested transport and
    a Metabase profile file is not found, configuration will offer to
    run metabase-profile to create it. [David Golden]

  - For Metabase transport (only), the 'id_file' may have a relative
    file path, treated as relative to the .cpanreporter directory.
    [David Golden]

  [BUG FIXES]
  - updated CPAN::Reporter to go with Metabase by default, instead of
    the deprecated SMTP transport system. This provides more up-to-date
    information for new testers on how to setup their systems and
    addresses RT#64316 (and maybe also RT#61735) [Breno G. de Oliveira]

  - Replaced use of Tee.pm with Capture::Tiny as the two don't play
    well together on some systems. [Christian Walde]

  [DOCUMENTATION]
  - Docs have been substantially re-written to reflect the new HTTP-based
    transport instead of email-based transport. [Breno G. de Oliveira and
    David Golden]

1.1902    2011-01-28 15:22:35 EST5EDT

  [BUG FIXES]

  - Updated Tee prereq to 0.14 to fix an instability on Windows

1.1901    2011-01-24 20:23:23 EST5EDT

  - Fixes some space and backslash escaping for Windows [Christian Walde]

1.1900    2011-01-21 10:55:28 EST5EDT

  - No changes from 1.18_06

1.18_06   2010-12-07 05:18:51 EST5EDT

  Fixed:

  - Reports with a "can't spawn" error from TAP::Parser::Iterator::Process
    are discarded instead of reporting FAIL

  Other:

  - CPAN::Reporter is now released using Dist::Zilla.  This required
    some changes to various files help dzil find/skip various bits of data.
    It should have no runtime effect.

1.18_05 Sun Oct 24 21:25:22 EDT 2010

  Fixed:

  - Fixed error in calling prerequisite detection script when there
    are spaces in the path [RURBAN]

1.18_04 NOT RELEASED TO CPAN

  Changed:

  - Executed processes are given their own process group and timeouts are
    now handled by sending SIGKILL to the entire child process group.
    This is an attempt to address RT#61912

1.1803 Thu Sep 30 21:49:10 EDT 2010

  Fixed:

  - Fixed t/13_record_command.t to reflect removal of Proc::ProcessTable
    as a conditional dependency and fixed a resulting bug in the test
  
  - Removed mention of Proc::ProcessTable in CPAN::Reporter::Config

1.1802 Wed Sep 29 23:19:15 EDT 2010

  Changed:

  - Given the migration to CT2.0, the maximum report length before
    truncation has been increased from 50 to 1,000 kB.

  - Removed dependency on Proc::ProcessTable for using a command timeout
    on non-Win32 platforms.

1.1801 Fri Sep 10 16:34:29 EDT 2010

  Changed:

  - Default config directory now uses File::HomeDir->my_home on
    windows instead of ->my_documents.  If that directory doesn't exist,
    it will fall back to ->my_documents.

1.1800 Mon Jul 26 16:02:06 EDT 2010

  Changed:

  - "sending test report..." message now shows transport method, not
    the old email list address for less confusion when using non-email
    transports

  - Enhances missing "email_from" prompt to clarify why an email is
    still needed under non-email transports for legacy compatibililty

1.1711 Wed Feb 17 13:52:14 EST 2010

  Bugs fixed:

  - Tests for "no make test" were failing due to internationalization
    of the error message.  Rather than try to interpret every possible
    make error message, CPAN::Reporter now just looks inside the Makefile
    for a "test" target.  Hopefully, that will prove more robust.

1.1710 Wed Feb 10 10:30:51 EST 2010

  Bugs fixed:

  - Tests for "no make test" were failing on some systems due to
    the incredibly wide range of error messages possible from
    make/nmake/dmake on various systems.  The error message check is
    now even more liberal.

1.1709 Mon Feb  1 22:39:59 EST 2010

  Bugs fixed:

  - Fixed PrereqCheck for modules like "if.pm" that could be confused
    with Perl syntax (RT#53477 by Serguei Trouchelle)

  - Added PrereqCheck special-case for Module::Install and improved
    diagnostics when prereqs are missing or too low (RT#51257)

  - Distributions with no 'make test' target should be UNKNOWN,
    not FAIL (RT#52139)

  - Improved detection of Test::Reporter capable of setting 'distfile'
    parameter

  Documentation changes:

  - Added 'Port' example for transport options

  - Adopted new format for Changes

1.1708 Mon Jun  1 23:31:58 EDT 2009

    *** Emergency fix -- 1.1706/1.1707 can prevent subsequent module  ***
    *** installation if installed with an older Test::Reporter.       ***
    *** Disable test reporting (From CPAN, 'o conf test_report 0')    ***
    *** and install CPAN::Reporter 1.1708.  Then re-enable test       ***
    *** reports.                                                      ***

    - Fixed: in the case where an old Test::Reporter without the distfile()
      method is installed, CPAN::Reporter would crash and prevent
      installation of modules (including newer Test::Reporter); now checks
      for a Test::Reporter

1.1707 Sun May 31 21:44:07 EDT 2009

    - Prereq: bumped Test::Reporter to 1.54

1.1706 Sun May 31 14:00:43 EDT 2009

    - Changed: URL of CPAN Testers wiki is now wiki.cpantesters.org

    - Added: support for setting 'distfile' parameter for test reports
      if supported by Test::Reporter (1.53_01+)

1.1705 Tue Jan 20 10:51:24 EST 2009

    - Docs: CPAN Testers website updated to www.cpantesters.org
      (David Westbrook)

1.1704 Sun Dec  7 06:24:07 EST 2008

    - Fixed: protect CPAN::Reporter tests from older versions of itself

    - Prereq: bumped Devel::Autoflush to 0.04 and CPAN to 1.9301

1.1703 Fri Dec  5 23:06:20 EST 2008

    - Changed: Devel::Autoflush only added to PERL5OPT when capturing
      output from Makefile.PL or Build.PL

    - Prereq: bumped Devel::Autoflush to 0.03 for various fixes

1.1702 Sat Sep 13 07:20:04 EDT 2008

    *** Emergency fix -- 1.1701 tickled a new Test::Harness bug ***

    - Changed: reverted to old -I and -M flag order in PERL5OPT; -I flag
      only added on Perl 5.8+; this should still fix Perl < 5.8 that can
      only take a single flag without provoking the T::H bug


1.1701 Thu Sep 11 23:56:41 EDT 2008

    - Fixed: changed order of -I and -M flags in PERL5OPT to have -M first
      (since Perl 5.6.2 only supports a single flag); 5.6.2 testers may yet
      again see complaints about missing Devel::Autoflush when authors call
      'perl' instead of $^X in tests (oh, well...)

    - Changed: bumped Test::Reporter prereq to 1.50

1.17 Sat Sep  6 19:35:44 EDT 2008

    - Changed: In line with changes to CPAN Testers grade definitions,
      failures during the PL or make/Build phase will now be reported as
      UNKNOWN instead of FAIL

    - Removed: In line with the CPAN Testers decision to no longer have
      individual testers send reports to authors, the "cc_author" option
      has been removed

    - Fixed: "Build -j3" type errors are detected and reports discarded

    - Fixed: Makefile out of date vs Makefile.PL errors detected and discarded

    - Docs: updated FAQ

1.16_51 Wed Jul 16 12:41:48 EDT 2008

    - Fixed: t/11_env_config was failing when tested under
      CPAN::Reporter due to PERL5OPT manipulations

1.16_50 Wed Jul 16 09:41:20 EDT 2008

    - Added: restored "-I" for PERL5OPT, but to a temporary lib
      directory containing a copy of Devel::Autoflush.

    - Fixed: enviroment variables section of report now reflects
      PERL5OPT as used during build and testing

1.1601 Sat Jul  5 09:37:14 EDT 2008

    - Fixed: reverted 1.15_56 PERL5OPT changes; Devel::Autoflush INC path
      no longer added with "-I" as it causes old modules to be found during
      testing.  Testers will have to live with authors complaining about
      Devel::Autoflush missing when authors call 'perl' instead of $^X

    - Fixed: timeout support on *nix checks for *both* Proc::Killfam and
      Proc::ProcessTable to protect against unauthorized copies of only
      Proc::Killfam bundled in distributions like Tk-ExecuteCommand

1.16 Fri Jul  4 09:14:52 EDT 2008

    - No changes since 1.15_56

    - Summary of major features/fixes since 1.15:

        - Added: support for 'configure_requires' in META.yml (adds
          Parse::CPAN::Meta as dependency)

        - Fixed: uses Devel::Autoflush to ensure buggy *.PL files that
          prompt without a newline are always visible through the 'tee'
          pipe

        - Fixed: on Unix, changed command timeout approach to avoid
          disconnecting STDIN from the terminal; timeouts now require
          Proc::Killfam on *nix platforms

1.15_56 Thu Jun 19 22:19:33 EDT 2008

    - Fixed: when multiple versions of perl are installed, distributions
      that called 'perl' during testing instead of '$^X' would die trying
      to load Devel::Autoflush if the first perl in PATH didn't have
      Devel::Autoflush installed; fixed by added -I flag to PERL5OPT with
      the path to Devel::Autoflush to ensure it can be found; (calling
      'perl' is actually a subtle testing bug, but this way it doesn't look
      like it's the tester's fault)

    - Documented: removed suggestion to subscribe to cpan-testers since
      that no longer is necessary now that cpan-testers is just a
      drop-box (noted by Jose Luis Martinez)

1.15_55 Mon Jun  9 08:11:01 EDT 2008

    - Fixed: catch META.yml parse failures from Parse::CPAN::Meta
      (Reported by Andreas Koenig)

1.15_54 Fri Jun  6 14:06:57 EDT 2008

    - Fixed: would disconnect from terminal input when running interactively
      with an inactivity timeout; fixed by avoiding use of setpgrp(), but
      now requires Proc::Killfam to support inactivity timeouts on non Win32
      platforms. (Bug reported by Andy Armstrong)

1.15_53 Thu Jun  5 06:37:13 EDT 2008

    - Fixed: PERL5OPT could was being set with a leading space, which can
      break distributions being tested under Test::Harness

1.15_52 Wed Jun  4 22:23:39 EDT 2008

    - Fixed: t/11_env_config.t had a bug that would fail incorrectly if
      an environment variable had a leading space

1.15_51 Wed Jun  4 17:57:42 EDT 2008

    - Fixed: t/13_record_command.t relative path tests are incompatible
      with Devel::Autoflush; removed the broken tests

1.15_50 Tue Jun  3 12:13:12 EDT 2008

    - Added: on FAIL reports, now checks for missing configure_requires
      and discards the report if configure_requires is not satisfied.
      (Adds Parse::CPAN::Meta as dependency.)

    - Fixed: some *.PL files prompt without autoflush, which works
      normally, but appears to silently hang when piping to a tee.
      CPAN::Reporter now uses Devel::Autoflush in PERL5OPT to always turn
      on autoflush

    - Fixed: distributions with odd names wouldn't be recorded in history;
      now they are recorded as 'DISCARD'

1.15 Mon May 19 11:21:47 EDT 2008

    - Changed: now requires Test::Reporter 1.40

    - No other changes from 1.14_xx series

1.14_04 Thu Apr 17 06:37:26 EDT 2008

    - Documented: added section on transport config option

1.14_03 Thu Apr 17 06:37:26 EDT 2008

    - Uploaded without Changes file updated

1.14_02 Sun Apr  6 09:45:39 EDT 2008

    - Changed: improved diagnostics messages for 'transport' failures

1.14_01 Sat Apr  5 18:30:44 EDT 2008

    - Changed: if 'transport' configuration option is not valid according
      to Test::Reporter, no report will be sent instead of falling back
      to Net::SMTP

1.13 Mon Mar 24 09:22:44 EDT 2008

    - Changed: Build.PL or Makefile.PL that returns without error but
      does *not* create either 'Makefile' or 'Build' will be marked as
      'DISCARD' for the PL phase instead of 'PASS'.

    - Fixed: Prereq check would be confused if loading modules also
      printed anything to STDOUT (somehow CPAN.pm is a culprit); added
      "select DEVNULL" before requiring modules as a workaround

1.12 Mon Mar 10 08:55:48 EDT 2008

    - Added: Win32::FsType() to special variables section of report

    - Added: diagnostic warning if PrereqCheck output can't be parsed

1.11 Mon Feb 25 18:47:03 EST 2008

    - Bug fix: successful PL's where prereqs happen not to be satisfied
      were mistakenly being marked as 'DISCARD' for the PL phase.  Fixed so
      that PL's that PASS will stay that way regardless of prerequisites.
      (This does not prevent a later make or test failure from being
      downgraded,

    - Bug fix: skipfiles patterns should match case-insensitive (Cantrell);
      also, documented lack of starting anchor

    - Bug fix: command_timeout option would not accept zero as valid; now
      zero is a valid option and disables command_timeout

    - more minor boilerplate tweaks

1.10 Mon Feb 25 10:07:28 EST 2008

    I hereby dub 1.10 as the "I hate Windows" release

    - Bug fix (sort of): On Win32, child processes were not timing out.
      Changed from Win32::Process to Win32::Job to fix that.  However,
      discovered that process termination on Win32 can deadlock in some
      cases, so timeout testing on Win32 will now skip unless
      $ENV{PERL_AUTHOR_TESTING} is set. Added warning to documentation.

    - Bug fix: On a Win32 virtual machine (VirtualBox), handles for output
      capture were not inherited by child processes, which caused Test::Harness
      to crash for some reason.

1.09 Mon Feb 18 22:10:55 EST 2008

    - Simplified and shortened boilerplate

    - Bug fix (minor): better detection of make vs Build for progress
      messages

    - Test fix: skip interrupt testing on MSWin32 if Win32::Process
      is not installed

1.0801 Sun Feb 10 00:27:05 EST 2008

    - Test fix: adjust timeout timings in t/14_command_timeout.t to try to
      avoid failures on heavily loaded machines

1.08 Sat Jan 26 18:52:45 EST 2008

    - No changes from 1.07_06 (seems to pass smoke tests)

    - Summary of new features since 1.06:

        - Added have_tested() function to CPAN::Reporter::History

        - Added 'cc_skipfile' and 'send_skipfile' advanced config options

        - Added 'command_timeout' advanced config option

        - Added support for PERL_CPAN_REPORTER_DIR and
          PERL_CPAN_REPORTER_CONFIG environment variables

1.07_06 Fri Jan 25 11:27:28 EST 2008

    - Added 'command_timeout' config to halt commands after a period of time

    - Added detection of commands killed with a signal; reports are discarded
      (N.B. this may change in a future version)

    - Bug fix: processes timing out could still hang with child processes
      (killing 'make test' still leaves the harness running); fixed by making
      'make test' its own process group and killing the process group; hoping
      that's portable across non-Win32; Win32 timeouts use Win32::Process and
      do the right thing already

    - Downgraded lots of progress messages from CPAN's 'mywarn' to 'myprint'
      (from red to blue if you use CPAN's colored output)

1.07_05 Thu Jan 24 08:27:48 EST 2008

    - Added PERL_CPAN_REPORTER_DIR and PERL_CPAN_REPORTER_CONFIG environment
      variables to specify alternate locations for default configuration
      directory and file (RT#30314)

    - Removed File::Temp as a full prerequisite; now only used in testing
      (Requested by Adam Foxson to extract features to CPAN::Testers::*)

1.07_04 Sun Jan 20 22:06:56 EST 2008

    - Test fix: stopping cc on blead broke lots of other tests.  Fixed those.
      Built my own blead perl so I can actually check these things in the
      future instead of relying on Andreas' blead smoking

    - Test fix: testing skipfile wasn't being created properly on Perl 5.005

1.07_03 Sat Jan 19 22:16:44 EST 2008

    - Test fix: set sample history file writeable after copy

1.07_02 Sat Jan 19 20:33:55 EST 2008

    - Added have_tested() function to CPAN::Reporter::History; provide ability
      to search the CPAN::Reporter history file

    - Bug fix: PL files that warned "OS Unsupported" and exited with 0 will
      now be flagged as NA; this bends the CPAN Testers "rules" slightly, but
      "OS Unsupported" is a hack anyway, so this should help things DWIM

    - Test fix: more changes to timeout testing to avoid false failures

    - Authors will never be CC'd on reports when running maint/blead perl
      (anything with $Config{perl_patchlevel} set)

    - Reports discarded due to missing prerequisites will now be recorded
      in the history file with a 'grade' of DISCARD (unless a duplicate
      DISCARD already exists)

    - Changed "edit_report" prompt to clarify this can be used to review
      reports in addition to just editing them

    - Shortened duplicate report warning to fit on one line

1.07_01 Tue Jan  8 01:41:02 EST 2008

    - Added "cc_skipfile" and "send_skipfile" advanced config options to
      specify a text file of regex patterns; if a distribution ID
      ('AUTHOR/Dist-Name-0.01.tar.gz') matches any pattern in the file, the
      author will not be copied on the report (cc_skipfile) or no reports
      will be sent at all (skip_sendfile)

1.0602 Tue Dec 25 08:59:07 EST 2007

    - Test fix: a timeout test would sometimes appear to fail on a highly
      loaded system; changed the runtime and timeout timings to try to
      prevent false failures; added better diagnostic output

1.0601 Tue Dec 11 12:19:25 EST 2007

    - Test fix: Test::Harness 3.05 fixed a long standing bug; the fix
      broke our tests

1.06 Thu Nov 15 14:17:04 EST 2007

    - Bug fix: if older versions of a module are in multiple
      locations in @INC, CPAN::Reporter could detect the older version
      instead of the newer one; fixed in CPAN::Reporter::PrereqCheck
      (RT#30345; additional investigation by Andy Armstrong)

    - Bug fix: "our $VERSION" check still wasn't working on 5.005; now
      fixed (reported by Slaven Rezic).  Note, this situation only
      applies to Module::Build <= 0.2808, where Build.PL dies before a
      legitimate "require => { perl => 5.006 }" is processed. (Makefile.PL
      does not die in this situation and Makefile.PL has no way of
      signaling a required perl version other than "use 5.006" or equivalent
      in the Makefile.PL)

    - Bug fix: wasn't printing Test::Reporter error message if a report
      couldn't be sent (RT#30730 by BLOONIX)

    - Changed FAIL report boilerplate about CPAN::Testers wiki to be
      more explicit that the wiki teaches how to deal with dependencies, OS,
      etc. (suggested by Olly Betts)

1.05 Tue Nov  6 14:41:48 EST 2007

    - Added checks for Makefile.PL/Build.PL dying early on Perl < 5.6 if
      modules define their version using "our $VERSION"; such cases will
      be graded NA (RT#30299; report and partial patch from Slaven Rezic)

    - Added author's email address to the prompt question for whether to
      CC the author.  Also fixed typo in the prompt.
      (suggested by Slaven Rezic)

    - Added "CPAN::Reporter" consistently as a prefix to all console
      messages to distinguish them from messages from CPAN.pm. Noisy, but
      helps track errors/complaints to the right source.

    - Bug fix: on first installation, "reload cpan" might load CPAN::Reporter
      when an old version File::Temp is already loaded; added an explicit
      version check on File::Temp (reported by Andreas Koenig)

1.04 Fri Oct 26 06:56:32 EDT 2007

    - Bug fix: temp files were being created in the current directory,
      not the File::Spec->tmpdir() directory; this broke distributions
      that used their own distribution directory for signature or
      MANIFEST checks

1.03 Wed Oct 24 17:13:59 EDT 2007

    - Added a check for prerequisites that are present but fail to load;
      in such a case the prereq "have" field will show "broken" (e.g a
      dependency of that module is missing)

    - Refactored prerequisite checking code into a separate modulino
      CPAN::Reporter::PrereqCheck to cut down on excessive tempfile use
      and simplify testing

    - Added name templates for all tempfiles to help identify leakage
      or left-over files if tests are interrupted.  All names are like
      CR-ZZ-XXXXXXXX, where ZZ is unique to each File::Temp call and X's
      are a random suffix

    - Testing bug fix: in the rare case where Module::Build is present but
      broken, we would only skip Build.PL tests once instead of always

1.02 Sun Oct 14 08:57:38 EDT 2007

    - Bug fix: shell quotes in command passed to record_command() were not
      being properly escaped in creation of the wrapper script
      (found by Andreas Koenig)

    - Bug fix: wasn't detecting Perl version too low during make/Build
      phase.  Reports were improperly graded as 'FAIL' instead of 'NA'
      (found by Slaven Rezic and David Cantrell)

    - Bug fix: wasn't detecting missing prerequisites during "make" phase
      and FAIL reports were being sent that should have been discarded
      (found by Michel Rodriguez and David Cantrell)

1.01 Sat Oct 13 03:21:40 EDT 2007

    - Bug fix: no prompt for sending reports was being shown if
      advanced send_*_report options were set.  (Found by David Cantrell)

    - Bug fix: was not detecting Module::Install's perl version warning
      (found by Slaven Rezic)

1.00 Wed Oct 10 20:39:42 EDT 2007

    *** New major release -- API changes and other enhancements ***

    Summary of major changes from 0.XX series:

    * Added support for reporting for *.PL and make/Build stages; bumped
      CPAN.pm prerequisite to 1.9203 to take advantage of this support

    * Added support for the forthcoming Test::Harness 3.00

    * Changed the name and format of the history file of sent reports to
      track history by PL/make/test phase.  Old history.db will be
      automatically upgraded to new reports-sent.db.

    * Moved 'cc_author' and 'send_duplicates' options from interactive
      to advanced (manual) configuration; defaults are strongly recommended

    * Bumped Test::Reporter prereq to 1.34 for transport() method and set
      default transport to Net::SMTP on all platforms

    Additional minor new change in 1.00:

    - Added CPAN Testers wiki URL to explanation paragraph for FAIL reports
      (request by Slavan Rezic)

0.99_15 Mon Oct  8 08:33:56 EDT 2007

    This release is dedicated to Slaven Rezic for boldly smoking with
    the pre-release of Perl 5.005_05.

    - Work around missing 5.005 Fcntl constants (noted by Slaven Rezic)

    - Fix bug detecting perl version failure in test output
      (found by Slaven Rezic while testing Sub::Uplevel on 5.00505)

    - Fix bug detecting OS unsupported in test.pl and make

    - Test output truncated at 50K to ensure reports will be accepted
      by perl.org's MX and to avoid excessive output in general
      (MX limitation noted by Slaven Rezic)

    - Added documentation note in History.pm that all methods are
      currently private

    - Removed API.pm and FAQ.pm from MANIFEST and tarball -- these are
      just source files for API.pod and FAQ.pod generated with Pod::WikiDoc

0.99_14 Tue Oct  2 14:49:40 EDT 2007

    * Bumped CPAN.pm prereq to 1.9203 -- fixes a bug where make/build
      continues even if Makefile/Build is missing, causing FAIL
      reports for modules that exit(0) without generating a Makefile.

    - Set transport() default to Net::SMTP; ensures CPAN::Reporter can
      work out-of-the-box on systems that happen to have Mail::Send and
      a broken sendmail installation

    - eliminated several Perl::Critic level 4-5 complaints

    - added some entries to the FAQ

0.99_13 Thu Sep 27 06:24:00 EDT 2007

    * Bump Test::Reporter prereq to 1.34 for transport() method.  Added
      "transport" advanced configuration option.
      (Requested by Andreas Koenig)

    - Improved robustness of conversion of old history files on Win32 for
      really old CPAN::Reporter history formats

    - Minor report format tweaks

0.99_12 Sun Sep 23 13:14:08 EDT 2007

    * Bumped CPAN.pm prereq to 1.92 (full support for PL/make)

    - Reordered report sections to move program output to immediately
      after tester comments; this keeps most relevant information at the
      top and prereqs and other context follow

    - Added perl version to the report intro paragraph since otherwise it
      doesn't appear until the "perl -V" output at the end of the report

    - Compressed UID/EUID variables to a single line in the report

    - Made report language less 'test' specific, since we can also report
      on PL or make failures

    - Changed the way perl version is stringified for history file entries to
      workaround an old bleadperl bug; (a "better safe than sorry" fix)
      (Reported by Andreas Koenig)

    - Cleans up temp directories in testing more frequently

0.99_11 Fri Sep 21 17:02:18 EDT 2007

    - Fallback to "make test" or "Build test" exit value when output parsing
      fails.  This supports custom testing in Makefile.PL or Build.PL
      (Reported on Prima by Dmitry Karasik)

0.99_10 Tue Sep 11 17:29:18 EDT 2007

    - Added advanced options "send_PL_report", "send_make_report" and
      "send_test_report" to override "send_report" for individual phases
      (requested by David Cantrell)

0.99_09 Mon Sep 10 09:50:57 EDT 2007

    - Fix test failure on bleadperl

0.99_08 Sat Sep  8 18:07:08 EDT 2007

    * History file of sent reports has a new name ('reports-sent.db') and a
      new format with phase of testing for report ('PL', 'make', 'test')

    - More robust check for Test::Harness 2.99_01 (works even with out-of-date
      releases of version.pm)

    - More refactoring of config/history functions into separate modules

0.99_07 Wed Sep  5 18:20:37 EDT 2007

    - Skips inactivity timeout on Win32 without Win32::Process >= 0.10
      (bug found by Corion)

    - Bails out on Test::Harness 2.99_01 (not supported)

0.99_06 Wed Sep  5 16:56:23 EDT 2007

    - Added support for new message format from Test::Harness alpha (2.99_02)

    - Changed grading for test files with no output from FAIL to UNKNOWN to
      harmonize with new Test::Harness approach

    - Falls back to overall 'make test' exit code for success or failure if
      recursive Makefile.PL's are detected; File::Find added to prereqs;
      Bumped EU::MM prereq to 6.36 to get bug fixes for recursion and more

    - record_command() wrappers do better error checking for exec failures

    - Bumped File::Copy::Recursive dependency to 0.35 (fixes Win32 bug)

    - More defensive test coding

    - changed to the Apache License, version 2.0; (it's clearer, relicensable,
      and is explicit about contributions)

0.99_05 Mon Aug 27 16:16:50 EDT 2007

    - Fixed copy/paste typo that caused testing to fail; (serves me right
      for rushing out 0.99_04 without using my normal release-testing script)

0.99_04 Mon Aug 27 07:40:59 EDT 2007

    - Merged changes from 0.4801

0.4801 Mon Aug 27 07:30:24 EDT 2007

    - File::Copy::Recursive 0.34 is badly broken on Windows, causing our
      tests to fail; added an "xcopy" workaround

0.99_03 Fri Aug 10 12:03:07 EDT 2007

    - Fixed broken PL tests when Module::Build is not available

    - Tweaked grade result message printed to screen

    - Noted in Pod that CPAN 1.91_53 is required for full support

    - Reordered Changes to be chronological

0.48 Tue Aug  7 16:28:42 EDT 2007

    - Bumped Test::More prereq to 0.62 (from 0.99_02)

    - More portable directory checks in test helper module

    - Cleaned up DOS/unix line endings in many files

0.99_02 Tue Aug  7 06:54:59 EDT 2007

    - Author tests (e.g. pod/pod-coverage) moved to 'author_t' directory

    - Module::Build subclass used for development moved to inc

    - Pulled forward maintenance changes from 0.47_01

    - Bumped Test::More prereq to 0.62

0.47_01 Sat Aug  4 00:09:54 EDT 2007

    - Added TEMP and TMPDIR to environment variables included in report

    - Changed inclusion of AUTHOR_TESTING environment variable
      to any matching /AUTHOR_TEST/

    - Changed how "Build.PL" is executed in tests to diagnose odd Cygwin
      failure; increased test diagnostics

0.99_01 Tue Jul 31 22:28:25 EDT 2007

    * Major API additions and configuration changes in preparation for
      adding Makefile/Build.PL and make/Build support into CPAN.pm

        * Deprecated test() function; test() separated into record_command()
          and grade_test() functions to support CPAN.pm sending
          reports from output generated indpendently from CPAN::Reporter,
          e.g. CPAN.pm using Expect with distroprefs

        * Added record_command() to wrap and tee a system() command and
          return results for further evaluation in grade_*() functions;
          wrapping used to capture exit values that would otherwise be lost
          from pipe to tee; will support CPAN inactivity timouts on both *nix
          and Win32

        * Added grade_PL() function to evaluate results of 'perl Makefile.PL'
          or 'perl Build.PL'; recognizes 'require 5.xxxxx' and unsupported
          OS error messages to be 'NA' as well as ordinary pass/fail outcomes

        * Added grade_make() function to evaluate results of 'make' or
          'Build'

        * Added grade_test() function to evaluate results of 'make test'
          or 'Build test' (refactored from old test() function)

        * Removed 'cc_author' and 'send_duplicates' options from normal
          interactive configuration; defaults will be used unless set
          manually in the configuration file

    - separated documentation into separate API and Config files to
      keep documentation simple in the primary CPAN::Reporter file

    - added YAML & YAML::Syck to list of toolchain module versions
      reported (i.e. determines if META.yml is used by CPAN.pm)

    - began refactoring configuration code: moved configuration
      defaults and validation into Config.pm

    - fixed bug in distribution-version string creation for .tar.bz2

0.46 Tue Jul 17 22:05:50 EDT 2007

    *** Significant improvements to NA report handling ***

        * Changes as per CPAN Testers specifications from Barbie
        * NA reports should now be sent to CPAN Testers instead of discarded

    - Tests that fail with 'OS Unsupported' or 'No support for OS' are
      now correctly identified as NA

    - FAIL/UNKNOWN grades results with unsatisfied prerequisites are
      discarded immediately instead of being flagged as NA

    - changed default configurations to automatically send NA just like PASS

    - interactive configuration now always shows recommended options
      in addition to any prior configuration

    - added CPAN Testers website and wiki to SEE ALSO in docs

    - improved tests for detecting reports sent/not-sent

0.45 Tue Jul  3 17:07:30 EDT 2007

    - distribution tests that bailout now detected as FAIL instead of UNKNOWN

    - UNKNOWN results when prereqs are missing are downgraded to NA
      (just like FAIL reports with missing prereqs already were)

0.44 Sun Jun 17 22:05:46 EDT 2007

    - searches through duplicate history file instead of loading as a hash

    - added flocking to history file read/write
      (and faked it for platforms that don't support flock)

    - duplicate history includes $Config{perl_patchlevel} if it exists

0.43 Tue Apr 24 22:55:32 EDT 2007

    - enhanced duplicate tracking to include Perl version (suggested by
      David Cantrell)

0.42 Tue Apr 24 00:27:56 EDT 2007

    - added "send_duplicates" option with default "no"; compares CPAN Testers
      subject lines (grade, distribution, version and platform) to previous
      test results and skips sending duplicate reports

0.41 Sun Mar 25 09:39:07 EDT 2007

    - test reports will not be sent if the distribution name doesn't appear
      appear to be an actual distribution with version and archive suffix
      (Suggested by Barbie)

    - refactored tests

    - fixed ID format in mock CPAN::Distributions used in testing

0.40 Wed Feb 28 23:30:13 EST 2007

    - eliminated Perl::Critic level 5 and (most) level 4 complaints

    - added defensive code in case CPAN.pm can't provide a valid Author
      object (Reported by David Cantrell)

0.39 Sat Feb 10 19:28:13 EST 2007

    - changed prereq version testing to better match approach used
      by CPAN.pm

    - added support for Module::Build-style extended prerequisite logic
      (e.g. ">= N.nn, !=M.mm" etc.)

0.38 Mon Dec  4 20:39:18 EST 2006
    - fixed uninitialized value warning in "Preparing test report for..."

0.37 Mon Dec  4 08:44:54 EST 2006
    - fixed false result given back to CPAN.pm when config file is missing
      but tests passed (Reported by Andreas Koenig)

0.36 Mon Dec  4 00:20:32 EST 2006
    - changed default for send_report to "no" for "na" reports to avoid
      sending spurious reports from prerequisites failures

    - customized email report intros for better help to module authors
      receiving a CC for various types of reports

    - removed email address for RT to reduce spam

    - Added a FAQ and example config.ini

0.35 Fri Nov 10 01:52:47 EST 2006

    - fixed environment report tests for the case of undefined/empty environment variables

    - added support for CPAN.pm ANSI color messages and prompts

0.34 Wed Nov  8 05:39:22 EST 2006

    - fixed test skip block count when Module::Build is not installed
      (reported by rinceWind)

0.33 Tue Nov  7 07:37:08 EST 2006

    - Added Test::Harness and Test::More to the modules included as
      part of the toolchain version report

0.32 Tue Nov  7 01:24:14 EST 2006

    - Added versions of module toolchain (e.g. CPAN, ExtUtils::MakeMaker,
      Module::Build, etc.) to test report

    - Added Pod warning about potential privacy issues from sending
      environment and other information as part of the test report

0.31 Mon Nov  6 13:38:57 EST 2006

    - replace broken 0.30 release

0.30 Mon Nov  6 13:29:03 EST 2006

    - changed report output to have a different introductory paragraph for
      each test grade to better clarify the meaning of 'unknown' and 'na'
      results from testing

    - added select environment variables and Perl special variables to
      generated report

    - added some addition clarifications in Pod

0.29 Sat Oct 28 13:36:26 EDT 2006

    *** Backward compatibility warning: See below and 0.28_51 change log ***

        * Config file location on Mac OS X
        * Config option format and semantics for action prompts

    - fixed RT#22557: recursive build directories with no tests will no longer
      cause an "unknown" grade if tests exist at the top-level directory

    - changed action prompt rules; default is always no unless otherwise
      specified -- the suggested rule from interactive configuration has no
      impact on parsing

    - changed default action for edit_report and send_report to "no" and "yes"
      respectively if the grade is pass to avoid holding up successful
      installations. (Suggested by Michael Schwern)

    - changed several tests to always mock configuration directory; prevents
      OS X config files from being migrated early during testing. (Reported by
      Michael Schwern).

    - added explanation of grade:action pairs during configuration

    - added validation of grade:action pairs during configuration

0.28_51 Mon Oct 23 23:47:33 EDT 2006

    *** Backward compatibility warning: configuration options have changed and
    config directory on OS X has changed ***

    - changed config directory on Mac OS X to ~/.cpanreporter instead of
      ~/Documents/.cpanreporter to be more like Unix; automatically moves
      config file if old directory is detected. (RT#22120)

    - changed action prompt configuration option format to support grade-
      specific actions (RT#21690)

    - fixed success/failure parsing when recursive make output is included;
      line parsing is now done in reverse and only the first matching line
      is used

    - changed perl version prerequisite logic; report will only be marked
      "na" if a perl version was explicitly set in the prerequisites;
      autodetection of low perl version was removed to eliminate spurious
      matches from recursive makes

    - added tests for report output format

0.28 Sun Oct  8 12:47:46 EDT 2006

    - fixed test programs to force cleanup temp directories
      (due to bug in File::Temp)

0.27 Wed Oct  4 14:04:08 EDT 2006

    *** Emergency bug fix ***

    - fixed fatal bug in prereq collection from some versions of CPAN.pm

0.26 Wed Oct  4 09:25:08 EDT 2006

    - fixed prereq tests: requiring "0" will now pass for modules with no
      $VERSION defined (will show that version '0' is installed)

    - fixed prereq tests for version.pm and bleadperl expansion of
      version numbers when stringified (1.2 becomes 1.200)

    - bumped ExtUtils::MakeMaker prereq version to 6.26 to ensure proper
      globbing of t/*.t files for Test::Harness

0.25 Tue Oct  3 23:00:02 EDT 2006

    - fixed prereq testing: tests are conducted in a perl subprocess to use
      same $ENV{PERL5LIB} as used for testing itself; necessary to support
      prerequisites that may be tested by CPAN.pm but not yet installed

    - added special logic for perl prerequisite version checks now that
      CPAN.pm passes it along

    - added tests for prereq reporting

0.24 Sun Oct  1 04:27:51 EDT 2006

    *** Emergency bug fix ***

    - added a dummy file to t/dist/NoTestFiles/t to ensure the directory
      is included in the distribution manifest and tarball; otherwise
      NoTestFiles tests fail

0.23 Fri Sep 29 14:35:49 EDT 2006

    - changed test.pl/ExtUtils::MakeMaker handling to wrap 'make test'
      execution with a standardized (parsable) string; does not run
      test.pl twice anymore (Jonathan Rockway)

    - added additional test distributions and added tests for diagnostic
      messages explaining each grade (coverage now > 90%)

0.22 Thu Sep 28 23:44:54 EDT 2006

    - added support for future CPAN.pm support for separate requires and
      build_requires prerequisites

    - changed prerequisites report for easier reading and to show requires
      and build_requires individually, if available from CPAN.pm

    - changed test.pl test grading under ExtUtils::MakeMaker from output
      parsing to determining the success or failure of a separate run of
      Makefile

0.21 Thu Sep 28 07:06:30 EDT 2006

    - added test.pl support with full capture of output (Tim Bunce)

    - added support for "NA" grade when prerequisites are not meta or
      Perl version is too low

    - refactored tests into separate files by grade

0.20 Sun Sep 24 22:45:48 EDT 2006

    - fixed RT#21626: "unknown" results will now be reported to CPAN.pm as
      success and will not interrupt module installation (Slaven Rezic)

    - added support for test.pl files -- though under "make", report is based
      on exit code only and no output is collected

    - added several new tests and test distributions for greater coverage and
      confirming bug closure

    - added user feedback for test grade assigned during report generation

    - changed format of test report

0.19 Fri Sep 22 16:54:02 EDT 2006

    - changed test IO capture to IO::CaptureOutput (fixes test issues
      for Perl < 5.8) (Andreas Konig)

0.18 Thu Sep 21 21:03:57 EDT 2006

    - added workaround for a bizarre VERSION() method confict when
      Module::Signature is installed on older Perls (Andreas Konig)

    - added note about location of config files for Mac OS X (SKUO)

    - updated "Getting Started" Pod now that CPAN 1.88 is out

0.17 Sat Sep  9 07:11:08 EDT 2006

    - changed t/03_test_report.t to skip Module::Build tests if
      Module::Build is not installed

0.16 Fri Sep  8 07:19:25 EDT 2006

    - fixed file mode bug in t/02_config_file_t (Slaven Rezic)

    - added first regression tests for pass/fail

0.15 Wed Sep  6 19:23:32 EDT 2006

    - fixed broken test() -- all tests were reporting failed

0.14 Wed Sep  6 15:53:52 EDT 2006

    - added configure() for config file generation and interactive config

    - removed automatic config file generation from the test() function

    - updated getting started documentation to reflect CPAN.pm
      'o conf init test_report' syntax (as of 1.87_59) and new
      interactive config feature of CPAN::Reporter

    - added the 'fail' config value; equivalent to 'yes' if a test failed
      and 'no' otherwise

    - changed "cc_author" default to "fail"

    - added error checks and testing for config file generation

0.13 Tue Aug 29 06:31:38 EDT 2006

    - added slightly more verbose progress messages, including for CC's and
      for reports not sent

    - minor documentation improvements

0.12 Sat Aug 26 19:05:54 EDT 2006

    - updated docs to indicate that CPAN 1.87_57 supports CPAN::Reporter

0.11 Sat Aug 26 12:20:32 EDT 2006

    - fail-safe test.pl files -- can't determine success for "make test"
      when teed and can't parse for Test::Harness output

    - fail-safe output parsing -- if the expected failure string from
      Test::Harness is not found, report "unknown" instead of fail

    - added compatibility for CPAN.pm "reload cpan" command (Andreas Konig)

    - added options "debug" and "editor" (Andreas Konig)

    - bumped Tee version requirement

0.10 Tue Aug  8 23:56:07 EDT 2006

    - first public release -- support not yet available in CPAN.pm
      main branch

# vim: ts=2 sts=2 sw=2 et tw=75 :
